# add '/usr/local/bin' to PATH on Mac OS system
if [[ "$(uname -s)" == "Darwin" ]] ; then
  PATH=/usr/local/bin:${PATH};
fi

_platform_=`/afs/.cern.ch/sw/lcg/external/MCGenerators/.scripts/check_platform`;

echo "INFO: initial LCG platform name: $_platform_";

_localbase_=;

unset _is64_;
if echo "$_platform_" | grep -E "amd64|x86_64" >&/dev/null ; then
  _is64_=yes;
fi;

case "$_platform_" in

  i[34567]686-slc4*|x86_64-slc4*|slc4_ia32*|slc4_amd64*)  

    false&&echo "WARNING: support of SL(C) 4.X is phased out"  ;
    ;;

  i[34567]86-slc5*)   

    false&&echo "WARNING: setting gcc43 as a default compiler on SLC 5.X"   ; 
      .  /afs/cern.ch/sw/lcg/contrib/gcc/4.3/i686-slc5-gcc43-opt/setup.sh ; 
    ;;

  x86_64-slc5*)
    
    false&&echo "WARNING: setting gcc43 as a default compiler on SLC 5.X"  ; 
      .  /afs/cern.ch/sw/lcg/contrib/gcc/4.3/x86_64-slc5-gcc43-opt/setup.sh;
    ;;

  i[34567]86-Linux*|x86_64-Linux*)

           echo "WARNING: you're using non SL(C) based Linux OS" ;
    echo "         Compatibility issues should be reported to"
    echo "         genser-developers@cern.ch" ;
           ;;

  i[3456]86-mac*) 
  
    _CROSS32_=yes ;
    if test "X$_platform_" != "Xi386-mac106-gcc42-opt" ; then
      echo "WARNING: you're using an unsupported OS X environment.";
      echo "         Be cautious! Compatibility issues should be ";
      echo "         reported to genser-developers@cern.ch" ;
    fi;
    ;;

  x86_64-mac*) 

    # point to place with 64bits libgfortran.dylib:
    export DYLD_LIBRARY_PATH=/usr/local/lib/x86_64:${DYLD_LIBRARY_PATH}
    
    if test "X$_platform_" != "Xx86_64-mac106-gcc42-opt" ; then
      echo "WARNING: you're using an unsupported OS X environment.";
      echo "         Be cautious! Compatibility issues should be ";
      echo "         reported to genser-developers@cern.ch" ;
    fi;
    ;;

  *)
    echo "ERROR: you're using an usupported environment: ${_platform_}" >&2;
    echo "       If you think it should be supported, ">&2;
    echo "       please contact genser-developers@cern.ch" >&2 ;
    ;;
esac;

_platform_=`/afs/.cern.ch/sw/lcg/external/MCGenerators/.scripts/check_platform`;
                
echo "INFO: final LCG platform name: $_platform_";

